<?php

  function totalEmployeePerDay( $_start_day, $_end_day='')
  {
      global $host;
      global $user;
      global $password;
      global $dbname;
      $start_day = clone $_start_day;
      $end_day   = clone $_end_day;

      $MIN_ITEMS_PROCESSED = 10;
      
      $conn = new mysqli($host, $user, $password,  $dbname)
    	   or die ('Could not connect to the database server' . $conn->connect_error);
      
      if ( empty($end_day))
      {
        $end_day=new DateTime();
      }
      
      $today = new DateTime();

      $current_day = $start_day;
      
      $workers_per_day = array();
      while( $current_day->format("Y-m-d") <= $end_day->format("Y-m-d"))
      {      
        $worker_per_day[$current_day->format("Y-m-d")] = array();        
        $sql = "select count(user_id) as workers from (select user_id,sum(items_processed) as items from daily_stats where day='".$current_day->format("Y-m-d")."' and hour<14 group by user_id)a where items>".$MIN_ITEMS_PROCESSED;
        $res = $conn->query($sql);
        
        if ( $res && ($res->num_rows >0))
        {
          while( $row = $res->fetch_assoc())
          {
            $workers_per_day[$current_day->format("Y-m-d")]["shift_1"] = $row["workers"];
          } 
        } 
        $sql = "select count(user_id) as workers from (select user_id,sum(items_processed) as items from daily_stats where day='".$current_day->format("Y-m-d")."' and hour>=14 group by user_id)a where items>".$MIN_ITEMS_PROCESSED;  
        $res = $conn->query($sql);
        
        if ( $res && ($res->num_rows >0))
        {
          while( $row = $res->fetch_assoc())
          {
            $workers_per_day[$current_day->format("Y-m-d")]["shift_2"] = $row["workers"];
          } 
        }
         
        $workers_per_day[$current_day->format("Y-m-d")]["total"] = $workers_per_day[$current_day->format("Y-m-d")]["shift_1"] + $workers_per_day[$current_day->format("Y-m-d")]["shift_2"];  
        
        $current_day = date_add($current_day, date_interval_create_from_date_string('1 days'));
      }
      
      if ( $today->format("Y-m-d") == $end_day->format("Y-m-d"))
      {
        $worker_per_day[$end_day->format("Y-m-d")] = array();
        $sql ="select user_id, count(db_item_id) from items where date(processed_time) = '".$end_day->format("Y-m-d")."' and hour(processed_time) < 14 group by user_id having count(db_item_id)>".$MIN_ITEMS_PROCESSED." order by user_id";
        $res = $conn->query($sql);
        $workers_per_day[ $end_day->format("Y-m-d")]["shift_1"] = $res->num_rows;
        
        $sql ="select user_id, count(db_item_id) from items where date(processed_time) = '".$end_day->format("Y-m-d")."' and hour(processed_time) >= 14 group by user_id having count(db_item_id)>".$MIN_ITEMS_PROCESSED." order by user_id";
        $res = $conn->query($sql);
        $workers_per_day[ $end_day->format("Y-m-d")]["shift_2"] = $res->num_rows;
        
        $workers_per_day[$end_day->format("Y-m-d")]["total"] = $end_per_day[$current_day->format("Y-m-d")]["shift_1"] + $workers_per_day[$end_day->format("Y-m-d")]["shift_2"];
      }
      
      return $workers_per_day;
  }
  
  function getTotalItemsPerDays( $start_day, $end_day = '')
  {
      global $host;
      global $user;
      global $password;
      global $dbname;

      $MIN_ITEMS_PROCESSED = 10;
      
      $conn = new mysqli($host, $user, $password,  $dbname)
    	   or die ('Could not connect to the database server' . $conn->connect_error);
      
      if ( empty($end_day))
      {
        $end_day=new DateTime();
      }
      $total_items_per_day = array();
      $_tmp_start = clone $start_day;
      
      while ( $_tmp_start <= $end_day )
      {
          $total_items_per_day[ $_tmp_start->format("Y-m-d")]= array( "shift_1" => array( "items"   => 0, 
                                                                                         "items_3" => 0,
                                                                                         "items_5" => 0),
                                                                      "shift_2" => array( "items"   => 0, 
                                                                                         "items_3" => 0,
                                                                                         "items_5" => 0),
                                                                      "total"   => array( "items"   => 0, 
                                                                                         "items_3" => 0,
                                                                                         "items_5" => 0)                                                                                         );
          $_tmp_start = date_add($_tmp_start, date_interval_create_from_date_string('1 days'));                                                                                         
      }
      
      $today = new DateTime();
      $today = $end_day;
      $current_day = $start_day;
      
      
      $sql = "select * from total_stats where day>='".$start_day->format("Y-m-d")."' and day<='".$end_day->format("Y-m-d")."' order by day,shift";
      $res = $conn->query($sql);
      
      if ( $res && ($res->num_rows >0))
      {
          while( $row = $res->fetch_assoc())
          {
            
            if ( !array_key_exists( $row["day"], $total_items_per_day))
            {
            
              //$total_items_per_day[ $row["day"]] = array( );
            } 
            
            if ( strcmp(trim($row["shift"]),"0") == 0)
            {
              
              $total_items_per_day[ $row["day"]]["shift_1"]["items"]   = $row["processed_items"];
              $total_items_per_day[ $row["day"]]["shift_1"]["items_3"] = $row["items_stat3"];
              $total_items_per_day[ $row["day"]]["shift_1"]["items_5"] = $row["items_stat5"];
            }
            else
            {
              $total_items_per_day[ $row["day"]]["shift_2"]["items"]   = $row["processed_items"];
              $total_items_per_day[ $row["day"]]["shift_2"]["items_3"] = $row["items_stat3"];
              $total_items_per_day[ $row["day"]]["shift_2"]["items_5"] = $row["items_stat5"];
              
                                                                     
              $total_items_per_day[ $row["day"]]["total"]["items"]   = $total_items_per_day[ $row["day"]]["shift_1"]["items"] + $total_items_per_day[ $row["day"]]["shift_2"]["items"];
              $total_items_per_day[ $row["day"]]["total"]["items_3"] = $total_items_per_day[ $row["day"]]["shift_1"]["items_3"] + $total_items_per_day[ $row["day"]]["shift_2"]["items_3"];
              $total_items_per_day[ $row["day"]]["total"]["items_5"] = $total_items_per_day[ $row["day"]]["shift_1"]["items_5"] + $total_items_per_day[ $row["day"]]["shift_2"]["items_5"];   
                                                                       
            }
            
          } 
      }
      
      if ( $today->format("Y-m-d") == $end_day->format("Y-m-d"))
      { 
          //echo $today->format("Y-m-d").":".$end_day->format("Y-m-d");
//          $total_items_per_day[ $end_day->format("Y-m-d")] = array( "shift_1"=>array("items"=>0, "items_3"=>0,"items_5"=>0), "shift_2"=>array("items"=>0, "items_3"=>0,"items_5"=>0));//);
          $sql = "select item_status,count(db_item_id) as items from items where date(processed_time)='".$end_day->format("Y-m-d")."' and hour(processed_time) < 14 group by item_status order by item_status";
          $res = $conn->query($sql);
          
          if ( $res && ($res->num_rows >0))
          {
            while( $row = $res->fetch_assoc())
            {
                if ( $row["item_status"] == 1)
                {
                    $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items"] = $row["items"];
                }
                else if( $row["item_status"] == 2) 
                {
                  $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_3"] = $row["items"];
                }
                else if ( $row["item_status"] == 4)
                {
                  $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_5"] = $row["items"];
                }
            }
            $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items"] = $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items"] + $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_3"] + $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_5"]; 
          }
          /*else
          {
            $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]= array( "items" => 0, "items_3" => 0, "items_5" => 0);
          } */
          
          $sql = "select item_status,count(db_item_id) as items from items where date(processed_time)='".$end_day->format("Y-m-d")."' and hour(processed_time) >= 14 group by item_status order by item_status";
          
          $res = $conn->query($sql);

          if ( $res && ($res->num_rows >0))
          {
            while( $row = $res->fetch_assoc())
            {
                if ( $row["item_status"] == 1)
                {
                    $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]["items"] = $row["items"];
                }
                else if( $row["item_status"] == 2) 
                {
                  $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]["items_3"] = $row["items"];
                }
                else if( $row["item_status"] == 4)
                {
                  $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]["items_5"] = $row["items"];
                }
            }
            $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]["items"] = $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items"] + $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_3"] + $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_5"]; 
          }
          /*else
          {
            $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]= array( "items" => 0, "items_3" => 0, "items_5" => 0);
          } */
          
          $total_items_per_day[ $end_day->format("Y-m-d")]["total"] = array( "items"   => $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items"] + $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]["items"]  , 
                                                                             "items_3" => $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_3"] + $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]["items_3"],
                                                                             "items_5" => $total_items_per_day[ $end_day->format("Y-m-d")]["shift_1"]["items_5"] + $total_items_per_day[ $end_day->format("Y-m-d")]["shift_2"]["items_5"]);
      }
      
      return $total_items_per_day;
  }
  
  function getStartDateSinceBeginningOfWeek( $end_day = '')
  {
      if ( empty($end_day))
      {
        $end_day = date ("Y-m-d");
      }
      
      $dayofweek = $end_day->format("w");
      
      $days = $dayofweek - 1;
      
      return date_sub($end_day, date_interval_create_from_date_string( $days." days"));
  }
  
  function getItemsPerWeek( $weeks)
  {
      global $host;
      global $user;
      global $password;
      global $dbname;
      $conn = new mysqli($host, $user, $password,  $dbname)
    	   or die ('Could not connect to the database server' . $conn->connect_error);
      $week_data = array();
      $week_counter = 0;         
      foreach ( ($weeks) as $key=>$value)
      {
          $week_data[$week_counter] = array( "start" =>$value["start"], "end"=>$value["end"]);
          $sql = "select coalesce(sum(processed_items),0) as total,coalesce(sum(items_stat3),0) as items_3,coalesce(sum(items_stat5),0) as items_5 from total_stats where day>='".$value["start"]."' and day<='".$value["end"]."'";
          $res = $conn->query($sql);
          
          if ( $res && ($res->num_rows >0))
          {
            
            while( $row = $res->fetch_assoc())
            {
                $week_data[$week_counter]["total"]   = $row["total"];
                $week_data[$week_counter]["items_3"] = $row["items_3"];
                $week_data[$week_counter]["items_5"] = $row["items_5"];
            }
 
          }
          
          //add today from items if the week contains today
          $start_day = new DateTime( $value["start"]);
          $end_day   = new DateTime( $value["end"]);
          //$today     = new DateTime("2018-11-08");
          $today     = DateTime::createFromFormat( "Y-m-d", date('Y-m-d') );
          
          if ( ($today >= $start_day) && ($today <= $end_day ))
          {
              
              $sql = "select item_status,count(db_item_id) as items from items where date(processed_time)='".$today->format("Y-m-d")."' group by item_status";
              
              $res = $conn->query($sql);
          
              if ( $res && ($res->num_rows >0))
              {
            
                while( $row = $res->fetch_assoc())
                {
                    if ( $row["item_status"] == 1)
                    {
                        $week_data[$week_counter]["total"] += $row["items"];
                    }
                    else if ( $row["item_status"] == 2)
                    {
                        $week_data[$week_counter]["items_3"] += $row["items"];
                    }
                    else if ( $row["item_status"] == 4)
                    {
                        $week_data[$week_counter]["items_5"] += $row["items"];
                    } 
                }
              }
              
          }
          $week_counter++;
      } 
      $conn->close();
      return $week_data;
  }
  
  function getWeeksBetweenDates($_start_day, $end_day = '', $extend = true)
  {
      $start_day = clone $_start_day;
      if ( empty($end_day))
      {
        $end_day = date ("Y-m-d");
      }
      
      if ($extend)
      {
          $dayofweek = $end_day->format("w");
          moveDayToMonday( $start_day, false);
          moveDayToMonday( $end_day, true);
          if ( $dayofweek != 1)
          {
              date_sub($end_day, date_interval_create_from_date_string('1 days'));
          }
          else
          {
              //the end day should be sunday, so if it was at the beginning a monday move to NEXT sunday
              date_add($end_day, date_interval_create_from_date_string('6 days'));
          }
      }
      $weeks = array();
      $current_week = 0;
      while ( $start_day <=  $end_day ) 
      {
          $weeks[ $current_week]=array("start"=>$start_day->format("Y-m-d"));
          date_add($start_day, date_interval_create_from_date_string('6 days'));
          $weeks[$current_week]["end"]=$start_day->format("Y-m-d");
          date_add($start_day, date_interval_create_from_date_string('1 days'));
          $current_week++;
          //echo $start_day->format("Y-m-d")."=>".$start_day->format("W")."<br>";
                  
      }
      return $weeks;
  }
  
  function moveDayToMonday( $day, $move_forward = false)
  {
    if ( !empty($day))
    {
          $dayofweek = $day->format("w");
      
      #if it is not monday
      if ( $dayofweek != 1)
      {
          if ( $move_forward)
          {
              date_add( $day, date_interval_create_from_date_string( (8-$dayofweek)." days"));
          }
          else
          {
              date_sub( $day, date_interval_create_from_date_string( ($dayofweek-1)." days"));
          }
      }
    }
  }

  

?>